package brs.visitor;

import brs.*;

public class BRSEquals implements IVisitor {
    public static final BRSEquals Singleton = new BRSEquals();
    
    private BRSEquals() {}
    
    public Object emptyCase(BiTree host, Object... other) {
        return ((BiTree)other[0]).execute(new IVisitor() {
            public Object emptyCase(BiTree otherHost, Object... nu) {
                return true;
            }
            public Object nonEmptyCase(BiTree otherHost, Object... nu) {
                return false;
            }
        });
    }
    
    public Object nonEmptyCase(final BiTree host, Object... other) {
        return ((BiTree)other[0]).execute(new IVisitor() {
            public Object emptyCase(BiTree otherHost, Object... nu) {
                return false;
            }
            public Object nonEmptyCase(BiTree otherHost, Object... nu) {
                if(host.getRootDat().equals(otherHost.getRootDat())) {
                    return ((Boolean) host.getRightSubTree().execute(BRSEquals.this, otherHost.getRightSubTree())) 
                        && ((Boolean) host.getLeftSubTree().execute(BRSEquals.this, otherHost.getLeftSubTree()));
                }
                else {
                    return false;
                }
            }
        });
    }
}