package brs.visitor.test;

import brs.*;
import brs.visitor.*;
import junit.framework.TestCase;


public class BRSEquals_Test extends TestCase {
  
  public void test_BRSEQuals() {
    IVisitor algo = BRSEquals.Singleton;
    
    BiTree brs = new BiTree();
    BiTree other = new BiTree();
    
    assertTrue(brs.toString(), (Boolean) brs.execute(algo, other));
    
    brs.insertRoot("a");
    assertFalse(brs.toString(), (Boolean) brs.execute(algo, other));
    
    other.insertRoot("a");
    assertTrue(brs.toString(), (Boolean) brs.execute(algo, other));

    BiTree right = new BiTree();
    right.insertRoot("b");
    brs.setRightSubTree(right); 
    assertFalse(brs.toString(), (Boolean) brs.execute(algo, other));

    
    BiTree otherRight = new BiTree();
    otherRight.insertRoot("b");
    other.setRightSubTree(otherRight);
    assertTrue(brs.toString(), (Boolean) brs.execute(algo, other));

    BiTree left = new BiTree();
    left.insertRoot("c");
    brs.setLeftSubTree(left); 
    assertFalse(brs.toString(), (Boolean) brs.execute(algo, other));
    
    BiTree otherLeft = new BiTree();
    otherLeft.insertRoot("c");
    other.setLeftSubTree(otherLeft);
    assertTrue(brs.toString(), (Boolean) brs.execute(algo, other));
    
  }
  
}
