package brs.visitor;
import brs.*;

/**
 * Removes the root data of a Binary Search Tree
 *
 * Prob. 3.b:  This algorithm has a tendency to unbalance to tree
 * because it is always moving elements from the right side to the 
 * left side.   The solution from class doesn't do this.
 */
public class RemRootBST implements IVisitor {
    public static final RemRootBST Singleton = new RemRootBST ();
    private RemRootBST ()  {
    }

    /**
    * @param nu not used.
    */
    public Object emptyCase(BiTree host, Object... nu) {
      throw new IllegalStateException("Empty tree has no root data!");
    }

    /**
    * @param nu not used.
    */
    public Object nonEmptyCase (final BiTree host, Object... nu)  {
      return host.getLeftSubTree().execute(new IVisitor() {
        public Object emptyCase(BiTree leftHost, Object... nu) {
              return  host.remRoot();
        }
        
        public Object nonEmptyCase (final BiTree leftHost, Object... nu)  {
          return host.getRightSubTree().execute(new IVisitor() {
            public Object emptyCase(BiTree rightHost, Object... nu) {
              return host.remRoot();
            }
            public Object nonEmptyCase (final BiTree rightHost, Object... nu)  {
              BiTree rms = (BiTree)leftHost.execute(MaxTreeFinder.Singleton);
              rms.setRightSubTree(host.getRightSubTree());
              host.setRightSubTree(new BiTree());
              return host.remRoot();
            }
          });
        }
      });
    }
}

