package brs.visitor.test;

import brs.*;
import brs.visitor.*;
import junit.framework.TestCase;

/**
 * A JUnit test case class.
 * Every method starting with the word "test" will be called when running
 * the test with JUnit.
 */
public class RemRootBST_Test extends TestCase {
  
  public void test_RemRootBST() {
    BiTree bst = new BiTree();
    BiTree result = new BiTree(); 
    IVisitor insert = new BSTInserter();
    IVisitor remRoot = RemRootBST.Singleton;
    
    try{
      bst.execute(remRoot);
      fail("Empty tree should have thrown exception.");
    }
    catch(IllegalStateException e) {
    }
    catch(Exception e) {
      fail("Wrong exception thrown on empty tree: "+ e);
    }
    
    bst.execute(insert, 42);
    Object x = bst.execute(remRoot);
    assertEquals("removed 42", 42, x);
    assertEquals(bst.toString(), result.toString(), bst.toString());
    
    bst.execute(insert, 42);
    bst.execute(insert, 23);
    result.execute(insert, 23);
    x = bst.execute(remRoot);
    assertEquals("removed 42", 42, x);
    assertEquals(bst.toString(), result.toString(), bst.toString());

    bst.execute(insert, 89);
    result.setRootDat(89);
    x = bst.execute(remRoot);
    assertEquals("removed 23", 23, x);
    assertEquals(bst.toString(), result.toString(), bst.toString());
  
    bst.execute(insert, 33);
    bst.execute(insert, 99);
    result.setRootDat(33);
    result.execute(insert, 99);
    x = bst.execute(remRoot);
    assertEquals("removed 89", 89, x);
    assertEquals(bst.toString(), result.toString(), bst.toString());
    
    
    bst.getLeftSubTree().insertRoot(15);
    bst.execute(insert, 7);
    bst.execute(insert, 20);
    result.setRootDat(15);
    result.getLeftSubTree().insertRoot(7);
    result.getRightSubTree().setRootDat(20);
    result.execute(insert, 99);
    x = bst.execute(remRoot);
    assertEquals("removed 33", 33, x);
    assertEquals(bst.toString(), result.toString(), bst.toString());
    
  }
  
}
