package brs.visitor;
import brs.*;
import tree.*;

/**
 * Transforming a binary tree to an n-ary Tree.
 * Problem 4.d of exam 3.
 * STUDENTS TO COMPLETE
 * @author SW
 * @since April 28, 2006
 */
public class MakeTree2 implements IVisitor {
    public static final MakeTree2 Singleton = new MakeTree2 ();
    private MakeTree2 ()  {
    }
    
    /**
     * @param nu not used.
     * @return Tree an empty Tree.
     */
    public Object emptyCase(BiTree host, Object... nu) {
        return new Tree();  
    }
    
    /**
     * @param nu not used.
     * @return Tree equivalent to host.
     */
    public Object nonEmptyCase (final BiTree host, Object... nu)  {
        final Tree t = new Tree();  // create a new empty tree
        t.insertRoot(host.getRootDat());  // insert root data   
        
        return host.getLeftSubTree().execute(new IVisitor() {
            public Object emptyCase(BiTree leftHost, Object... nu) {
                return host.getRightSubTree().execute( new IVisitor() {
                    public Object emptyCase(BiTree rightHost, Object... nu) {
                        return t;
                    } 
                    public Object nonEmptyCase (BiTree rightHost, Object... nu)  {
                        t.set_leftMostChild((Tree)rightHost.execute(MakeTree2.this));
                        return t;
                    }
                });
            }
            public Object nonEmptyCase (final BiTree leftHost, Object... nu)  {
                t.set_leftMostChild((Tree) host.getRightSubTree().execute( new IVisitor() {
                    public Object emptyCase(BiTree rightHost, Object... nu) {
                        return leftHost.execute(MakeTree2.this);            
                    } 
                    public Object nonEmptyCase (BiTree rightHost, Object... nu)  {
                        Tree child = (Tree) leftHost.execute(MakeTree2.this);
                        child.set_rightSibling((Tree)rightHost.execute(MakeTree2.this));
                        return child;
                    }
                }));
                return t;
            }
            
        });
    }
}
